<template>
  <div>
    <CCard>
      <CCardHeader>
        <div>
          <font-awesome-icon :icon="['fas', 'sitemap']" />
          <strong>Groups</strong>
        </div>
        <div class="card-header-actions">
          <CButton
            type="submit"
            color="primary"
            :variant="'ghost'"
            @click="onShowDetail(0)"
          >
            <font-awesome-icon :icon="['fas', 'plus-circle']" class="width-1x" />
            Add Group
          </CButton>
        </div>
      </CCardHeader>

      <CCardBody>
        <group-search-form
          :default-condition="condition"
          :loading="loading"
          @submit="onSearch"
        />

        <group-table
          :data="data"
          :loading="loading"
          @show-detail="onShowDetail"
          @delete="onConfirmDelete"
          @on-control="on"
          @off-control="off"
        />

        <app-pagination
          :total="total"
          :page-size="limit"
          :current-page="page"
          :align="`end`"
          :disabled="loading"
          @page-change="onPageChange"
        />
      </CCardBody>

      <app-delete-confirm-dialog
        ref="deleteConfirmDialog"
        :name="'user'"
        @confirm="onDelete"
      />

      <group-detail-modal
        :id="selectedId"
        ref="groupDetailModal"
        @modify="refresh"
      />
    </CCard>
  </div>
</template>
<script>
import GroupTable from '~/components/organisms/groups/GroupTable'
import GroupDetailModal from '~/components/organisms/groups/GroupDetailModal'
import GroupSearchForm from '~/components/organisms/groups/GroupSearchForm'

import AppPagination from '~/components/atoms/AppPagination'
import AppDeleteConfirmDialog from '~/components/molecules/AppDeleteConfirmDialog'

import AsyncLoading from '~/mixins/do-async-loading'
import ConditionHandler from '~/mixins/condition'
import SearchFormHandler from '~/mixins/search-form'
import Paginator from '~/mixins/paginator'

export default {
  components: {
    GroupTable,
    AppPagination,
    AppDeleteConfirmDialog,
    GroupDetailModal,
    GroupSearchForm
  },

  mixins: [
    AsyncLoading,
    ConditionHandler,
    SearchFormHandler,
    Paginator
  ],

  data: () => {
    return {
      data: [],
      total: 0,
      resourceTypeName: 'group',
      selectedId: null
    }
  },

  mounted () {
    this.refresh()
  },

  methods: {
    /**
     * Call API get users by condition search
     * Show data on table result
     *
     * @return {Object} API response for error handle
     */
    async fetch () {
      const res = await this.$dam.getGroupList(Object.assign({}, this.query, { encode: true }))

      if (Array.isArray(res.data) && res.data.length) {
        this.total = res.meta.total
        this.data = res.data
      }

      return res
    },

    /**
     * Open group detail modal
     *
     * @param {Object} group - Current group
     */
    onShowDetail (id) {
      this.setSelectedId(id)
      this.$refs.groupDetailModal.open()
    },

    /**
     * Open confirm delete
     * If confirm then call delete group
     * Else cancel
     *
     * @param {String} id - group id
     */
    onConfirmDelete (id) {
      this.setSelectedId(id)
      this.$refs.deleteConfirmDialog.open()
    },

    /**
     * Call API delete.
     *
     * @param {String} selectedId - Group id
     */
    async delete (selectedId) {
      await this.$dam.deleteGroup({ id: selectedId })
    },

    /**
     * Set select id
     *
     * @param {Number} id - group id
     */
    setSelectedId (id) {
      this.selectedId = id
    },

    /**
     * Call API do on control group
     *
     * @param {Number} selectedId - group item id
     */
    async on (selectedId) {
      await this.$dam.groupOn({ id: selectedId })
      this.refresh()
    },

    /**
     * Call API do off control group
     *
     * @param {Number} selectedId - group item id
     */
    async off (selectedId) {
      await this.$dam.groupOff({ id: selectedId })
      this.refresh()
    }
  }
}
</script>
